"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _useCodeMirror = require("./useCodeMirror");

Object.keys(_useCodeMirror).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _useCodeMirror[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _useCodeMirror[key];
    }
  });
});

var _jsxRuntime = require("react/jsx-runtime");

var _view = require("@codemirror/view");

Object.keys(_view).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _view[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _view[key];
    }
  });
});

var _basicSetup = require("@codemirror/basic-setup");

Object.keys(_basicSetup).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _basicSetup[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _basicSetup[key];
    }
  });
});

var _state = require("@codemirror/state");

Object.keys(_state).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _state[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _state[key];
    }
  });
});
var _excluded = ["className", "value", "selection", "extensions", "onChange", "onUpdate", "autoFocus", "theme", "height", "minHeight", "maxHeight", "width", "minWidth", "maxWidth"];

var ReactCodeMirror = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
  var {
    className,
    value,
    selection,
    extensions = [],
    onChange,
    onUpdate,
    autoFocus,
    theme = 'light',
    height,
    minHeight,
    maxHeight,
    width,
    minWidth,
    maxWidth
  } = props,
      other = (0, _objectWithoutPropertiesLoose2.default)(props, _excluded);
  var editor = (0, _react.useRef)(null);
  var {
    state,
    view,
    container,
    setContainer
  } = (0, _useCodeMirror.useCodeMirror)({
    container: editor.current,
    value,
    autoFocus,
    theme,
    height,
    minHeight,
    maxHeight,
    width,
    minWidth,
    maxWidth,
    selection,
    onChange,
    onUpdate,
    extensions
  });
  (0, _react.useImperativeHandle)(ref, () => ({
    editor: container,
    state,
    view
  }));
  (0, _react.useEffect)(() => {
    setContainer(editor.current);
    return () => {
      if (view) {
        view.destroy();
      }
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", (0, _extends2.default)({
    ref: editor,
    className: "cm-theme-" + theme + (className ? " " + className : '')
  }, other));
});

ReactCodeMirror.displayName = 'CodeMirror';
var _default = ReactCodeMirror;
exports.default = _default;
//# sourceMappingURL=index.js.map